include \masm32\include\masm32rt.inc
include \masm32\include\msimg32.inc
includelib \masm32\lib\msimg32.lib

WinMain			PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
NewStar         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
Random          PROTO :DWORD
DrawStars		PROTO :RECT


GETV MACRO dVar
	mov eax,dVar 
  EXITM <eax>
ENDM

.const
IDI_ICON      equ 200
NumberOfStars equ 1000 		; No. Stars
StarStructureSize equ 28 	;Size Struct Star
SpeedMin equ 1 				; Low Speed or speedmin
SpeedMax equ 10 			;Max speed or speedmax

; ################################# required for Text Scroll !!!
IDT_STARS		equ 101
IDT_TEXT		equ 102

TEXTFONT		equ "Acknowledge -BRK-" ; you could have whatever font here! For Example "Viner Hand ITC" any fonts that are avialable in Microsoft Office Word!!!
COLORTEXT		equ 00FFFFFFh 			; Text coulor
SCROLLSPEED		equ 35 					; Scroll Speed -> a lesser Number = Faster!
FONTZ			equ 400

.data
ClassName		db 'DLGCLASS',0
DlgName			db 'MyDialog',0
AppName			db 'starfield window',0
EasternStar 	db FALSE ;Eastern Star Nv
Speed 			dd 1 ;speed
DisplaysTrolling db TRUE ;Drive type displayed or Displays Trolling

; ################################# required for Text Scroll !!!
;----------------------------------------------------------------------------
szWindowMsg db 'page up increase speed ,page down decreases speed :) ',0Dh,0Ah
            db 0Dh,0Ah
            db 'Welcome to MASM32, state of the art ',0Dh,0Ah
            db 0Dh,0Ah ; puts a space ! 
            db 'Windows assembler programming.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'are all part of writing assembler.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'structures, pointers, data sizes etc... ',0Dh,0Ah,0  
;----------------------------------------------------------------------------

ScrollOffset  DWORD	1

.data?
hIcon     		HICON     ?
hInstance 		HINSTANCE ?

hStars 			HANDLE ? ;H Stars
pStars 			dd ? ;P Stars
RandomNamePr 	dd ? ;Random Name Pr

hmainDC         HDC		?
hLayerDC1		HDC		?
hLayerDC2		HDC		?
hBmpMain		HBITMAP ?
hBmpLayer1		HBITMAP ?
hBmpLayer2		HBITMAP ?

hBgColor    	HBRUSH	?
hFontWindow		HFONT	?
rScroll			RECT   <?>

.code

start:
mov hInstance,rv(GetModuleHandle,0)

invoke InitCommonControls

invoke WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL msg:MSG
LOCAL hWnd:HWND

	; 101 = resource ID ... 
	invoke CreateDialogParam,hInstance,101,NULL,addr WndProc,NULL
	mov hWnd,eax

	invoke ShowWindow,hWnd,SW_SHOWDEFAULT
	invoke UpdateWindow,hWnd

	.while TRUE
        invoke GetMessage, ADDR msg, NULL, NULL, NULL
		.BREAK .if !eax || eax == -1
		.if !rv(IsDialogMessage,hWnd,ADDR msg)
			INVOKE TranslateMessage, ADDR msg
			INVOKE DispatchMessage, ADDR msg
		.endif
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hDC:HANDLE
LOCAL ps:PAINTSTRUCT
LOCAL rect:RECT

	.IF uMsg ==WM_INITDIALOG
		
		INVOKE SetWindowText, hWnd, addr AppName	
		INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, rv(LoadIcon, hInstance, IDI_ICON)
	
		mov hFontWindow,FUNC(CreateFont,15, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, SADD(TEXTFONT)) ; first number is the font size!!
	
	    INVOKE  GetClientRect,hWnd,ADDR rect
	
	 	invoke CreateSolidBrush,TRANSPARENT 
		mov hBgColor,eax
		
		
		;-------------- create main layer -----------------------
		;/* get current window-DC */
		mov hDC,FUNC(GetDC,hWnd)
		
		;/* create a compatible DC */
		mov hmainDC,FUNC(CreateCompatibleDC,hDC)
		
		;/* create bitmap and load it into new DC */
		invoke CreateCompatibleBitmap,hDC,rect.right,rect.bottom
		invoke SelectObject,hmainDC,eax
		
		;/* save returned dummy-bitmap for later deletion */
		mov hBmpMain,eax
		;--------------------------------------------------------
	
		;/* layer for drawing stars */
		mov hLayerDC2,rv(CreateCompatibleDC,hDC)
		mov hBmpLayer2,rv(SelectObject,hLayerDC2,rv(CreateCompatibleBitmap,hDC,rect.right,rect.bottom))
		
		;/* layer for draing text */
		mov hLayerDC1,rv(CreateCompatibleDC,hDC)
		mov hBmpLayer1,rv(SelectObject,hLayerDC1,rv(CreateCompatibleBitmap,hDC,rect.right,rect.bottom))
		
		;/* selct black brsuh -> this becomes the 'tansparent color' */
		invoke DeleteObject,rv(SelectObject,hLayerDC1,rv(GetStockObject,BLACK_BRUSH))
		invoke SetBkColor,hLayerDC1,0
		
		;/* white text */
		invoke SetTextColor,hLayerDC1,00FFFFFFh
		
		;/* selct new dont and save dummy-font-handel for later deletion */
		mov hFontWindow,rv(SelectObject,hLayerDC1,hFontWindow)
		
		invoke FillRect,hLayerDC2,ADDR rect,hBgColor ; color for about window

		
		invoke SelectObject,hDC,hFontWindow	  		
		invoke DrawText,hDC,ADDR szWindowMsg,-1,ADDR rScroll,DT_CALCRECT + DT_NOPREFIX + DT_LEFT + DT_TOP + DT_NOCLIP
		
		m2m rScroll.right,rect.right
		sub rScroll.right,5
		add rScroll.top,GETV(rect.bottom)
		add rScroll.bottom,eax	
				
		invoke ReleaseDC,hWnd,hDC	
		
		invoke SetTimer,hWnd,IDT_STARS,20,0
	    invoke SetTimer,hWnd,IDT_TEXT,SCROLLSPEED,0
	    
		invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, NumberOfStars * StarStructureSize
		mov hStars, eax
		invoke GlobalLock, hStars
		mov pStars, eax
		mov eax,1
		ret
 	.ELSEIF uMsg == WM_DESTROY
  
  		;????? chdc
		;invoke DeleteDC,chdc 

		invoke DeleteObject,rv(SelectObject,hLayerDC1,hFontWindow)
		
		invoke DeleteObject,rv(SelectObject,hmainDC,hBmpMain)
		invoke DeleteDC,hmainDC
		
		invoke DeleteObject,rv(SelectObject,hLayerDC1,hBmpLayer1)
		invoke DeleteDC,hLayerDC1
		
		invoke DeleteObject,rv(SelectObject,hLayerDC2,hBmpLayer2)
		invoke DeleteDC,hLayerDC2		

		invoke KillTimer,hWnd,IDT_STARS
		invoke KillTimer, hWnd, IDT_TEXT
  
		invoke GlobalUnlock, pStars
		invoke GlobalFree, hStars
		mov eax,1
		ret
		
	.elseif uMsg == WM_CLOSE
		invoke DestroyWindow,hWnd
		invoke PostQuitMessage,0
		mov eax,1
		ret	
	.ELSEIF uMsg == WM_KEYDOWN
		.IF wParam == VK_ESCAPE
			invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
		.ELSEIF wParam == VK_PGDN
			.IF Speed != SpeedMin
				dec Speed
			.ENDIF
		.ELSEIF wParam == VK_PGUP
			.IF Speed != SpeedMax
			inc Speed
			.ENDIF
		.ELSEIF wParam == VK_T
	        .IF DisplaysTrolling
	            mov DisplaysTrolling, FALSE
	        .ELSE
	            mov DisplaysTrolling, TRUE
	        .ENDIF
		.ENDIF
		mov eax,1
		ret
    .ELSEIF uMsg == WM_PAINT

		mov hDC,rv(BeginPaint,hWnd,ADDR ps)
        
        ;/* copy only what needed !!! */
		mov esi,ps.rcPaint.right
		mov edi,ps.rcPaint.bottom
		sub esi,ps.rcPaint.left
		sub edi,ps.rcPaint.top
		
		;/* merge layer 1 & 2 */
		;/* copy stars to main-buffer */
		invoke BitBlt,hmainDC,ps.rcPaint.left,ps.rcPaint.top,esi,edi,hLayerDC2,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
	  		
	    ;/* copy text over - black = transparent */
	  	invoke TransparentBlt,hmainDC,ps.rcPaint.left,ps.rcPaint.top,esi,edi,hLayerDC1,ps.rcPaint.left,ps.rcPaint.top,esi,edi,0
		
		;/* copy main-buffer to screen -> no flickering */
		invoke BitBlt,hDC,ps.rcPaint.left,ps.rcPaint.top,esi,edi,hmainDC,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
	  	
        invoke EndPaint,hWnd,addr ps
	  	mov eax,1
	  	ret
	.ELSEIF uMsg == WM_TIMER
   		
   		invoke GetClientRect,hWnd,ADDR rect
		
		.if wParam == IDT_STARS
			xor esi,esi
			invoke GetClientRect,hWnd,ADDR rect
			invoke FillRect,hLayerDC2,ADDR rect,rv(GetStockObject,BLACK_BRUSH)
			invoke DrawStars,rect
			invoke InvalidateRect,hWnd,NULL,FALSE  
		.elseif wParam == IDT_TEXT
			;/* invalidate outdated rect */
			invoke InvalidateRect,hWnd,ADDR rScroll,FALSE
			
			add rScroll.top,GETV(ScrollOffset)
			add rScroll.bottom,eax			
			.if SDWORD PTR rScroll.top >= GETV(rect.bottom)
				mov ScrollOffset,-1	
			.else
				.if SDWORD PTR rScroll.bottom <= GETV(rect.top)
				mov ScrollOffset,1		
				.endif	
			.endif	
			; clear LayerDC with currently selected brush (= black =tansparent color)
			invoke BitBlt,hLayerDC1,0,0,rect.right,rect.bottom,hLayerDC1,0,0,PATCOPY
			
			invoke DrawText,hLayerDC1,ADDR szWindowMsg,-1,ADDR rScroll,DT_CENTER or DT_TOP or DT_NOPREFIX or DT_NOCLIP
			
			;/* invalidate current rect */
			invoke InvalidateRect,hWnd,ADDR rScroll,FALSE
		.endif
         mov eax,1
         ret
      .ENDIF
      xor eax, eax
      ret
WndProc endp

DrawStars proc rect:RECT
LOCAL Xwindow:DWORD
LOCAL Ywindow:DWORD
LOCAL Xwindowdiv2:DWORD
LOCAL Ywindowdiv2:DWORD

	m2m Xwindow,rect.right
	m2m Ywindow,rect.bottom
	
	mov eax,Xwindow
	shr eax, 1 ; This gets the center point of screen to start starfield
	mov Xwindowdiv2, eax
  	mov eax,Ywindow
  	shr eax, 1 ; This gets the center point of screen to start starfield
	mov Ywindowdiv2, eax  

    xor ecx, ecx
    .WHILE ecx != NumberOfStars ;NbEtoile=No. Stars
      mov eax, StarStructureSize ;StarStructureSize=Size Struct Star
      mul ecx
      add eax, pStars
      mov ebx, eax
      ;----------------------------------------------;
      ;--- CHECK IF THE STAR IS ALWAYS GOOD ---;
      mov eax, Speed
      .IF dword ptr [ebx + 8] <= eax
        push ecx
        invoke NewStar,ebx,rect.right,rect.bottom,Xwindowdiv2,Ywindowdiv2 ;NewStar=New Star
        pop ecx
        mov EasternStar, TRUE
      .ENDIF
      ;----------------------------------------------;
      ;--- REPLACEMENT OF OLD ADDRESS ---;
      .IF DisplaysTrolling ; DisplaysTrolling=Displays Trolling or Drive type displayed???
        push dword ptr [ebx + 12]
        pop dword ptr [ebx + 20]
        push dword ptr [ebx + 16]
        pop dword ptr [ebx + 24]
      .ENDIF
      ;----------------------------------------;
      ;--- CALCULATION OF NEW ADDRESS ---;
      mov eax, Speed     ; Speed = Speed
      sub dword ptr [ebx + 8], eax
      mov eax, dword ptr [ebx]
      shl eax, 8
      cdq
      idiv dword ptr [ebx + 8]
      add eax, Xwindowdiv2
      mov dword ptr [ebx + 12], eax
      mov eax, dword ptr [ebx + 4]
      shl eax, 8
      cdq
      idiv dword ptr [ebx + 8]
      add eax, Ywindowdiv2
      mov dword ptr [ebx + 16], eax
      ;---------------------------;
      ;--- CORRECTION OF BUGS ---;
      .IF DisplaysTrolling && EasternStar ;Eastern Star Nv
        push dword ptr [ebx + 12]
        pop dword ptr [ebx + 20]
        push dword ptr [ebx + 16]
        pop dword ptr [ebx + 24]
        mov EasternStar, FALSE
      .ENDIF
      ;--------------------------------------------------------------------;
      ;--- CHECK IF THE STAR IS ALWAYS IN THE LIMITS OF THE SCREEN ---;
      mov eax, Xwindow
      mov edx, Ywindow    ;fenetre=window
      .IF dword ptr [ebx + 12] < 0 || dword ptr [ebx + 12] > eax || dword ptr [ebx + 16] < 0 || dword ptr [ebx + 16] > edx
        mov dword ptr [ebx + 8], 0
      .ENDIF
      push ecx
      ;---------------------------;
      ;--- COLOR OF THE STAR ---;
      xor eax, eax
      mov ah, cl
      mov al, ah
      shl eax, 8
      mov al, ah
      invoke CreatePen, PS_SOLID, NULL, eax
      push eax
      invoke SelectObject, hLayerDC2, eax
      ;--------------------------;
      ;--- DRAWING FROM THE STAR ---;
      push NULL
      .IF DisplaysTrolling
        push dword ptr [ebx + 24]
        push dword ptr [ebx + 20]
      .ELSE
        mov eax, dword ptr [ebx + 16]
        inc eax
        push eax
        push dword ptr [ebx + 12]
      .ENDIF
      push hLayerDC2
      call MoveToEx
      invoke LineTo, hLayerDC2, dword ptr [ebx + 12], dword ptr [ebx + 16]
      pop eax
      invoke SelectObject,hLayerDC2,eax
      invoke DeleteObject,eax
      pop ecx
      inc ecx
    .ENDW

	ret
	
DrawStars endp

NewStar PROC uses ebx pStar:DWORD,nx:DWORD,ny:DWORD,Xwindowdiv2:DWORD,Ywindowdiv2:DWORD
	mov ebx, pStar
	invoke Random, nx
	sub eax, Xwindowdiv2
	mov dword ptr [ebx], eax
	invoke Random, nx
	sub eax, Ywindowdiv2
	mov dword ptr [ebx + 4], eax
	mov dword ptr [ebx + 8], 256
	push Xwindowdiv2
	pop dword ptr [ebx + 12]
	push Ywindowdiv2
	pop dword ptr [ebx + 16]
	mov eax, pStar
	ret
NewStar ENDP 

Random PROC Limit:DWORD
	mov eax, RandomNamePr
	mov ecx, 23
	mul ecx
	add eax, 7
	and eax, 0FFFFFFFFh
	ror eax, 1
	xor eax, RandomNamePr
	mov RandomNamePr, eax
	mov ecx, Limit 
	xor edx, edx
	div ecx
	mov eax, edx
	ret
Random ENDP
end start
